## bcachefs-tools 0.1+git20201025.742dbbdb

=== Makefile ===

PREFIX?=/usr/local
PKG_CONFIG?=pkg-config
INSTALL=install
PYTEST=pytest-3
CFLAGS+=-std=gnu89 -O2 -g -MMD -Wall				\
	-Wno-pointer-sign					\
	-Wno-zero-length-bounds					\
	-fno-strict-aliasing					\
	-fno-delete-null-pointer-checks				\
	-I. -Iinclude -Iraid					\
	-D_FILE_OFFSET_BITS=64					\
	-D_GNU_SOURCE						\
	-D_LGPL_SOURCE						\
	-DRCU_MEMBARRIER					\
	-DZSTD_STATIC_LINKING_ONLY				\
	-DFUSE_USE_VERSION=32					\
	-DNO_BCACHEFS_CHARDEV					\
	-DNO_BCACHEFS_FS					\
	-DNO_BCACHEFS_SYSFS					\
	-DVERSION_STRING='"$(VERSION)"'				\
	$(EXTRA_CFLAGS)
LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)

VERSION?=$(shell git describe --dirty=+ 2>/dev/null || echo v0.1-nogit)

CC_VERSION=$(shell $(CC) -v 2>&1|grep -E '(gcc|clang) version')

ifneq (,$(findstring gcc,$(CC_VERSION)))
	CFLAGS+=-Wno-unused-but-set-variable
endif

ifneq (,$(findstring clang,$(CC_VERSION)))
	CFLAGS+=-Wno-missing-braces
endif

ifdef D
	CFLAGS+=-Werror
	CFLAGS+=-DCONFIG_BCACHEFS_DEBUG=y
endif
	CFLAGS+=-DCONFIG_VALGRIND=y

PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev"
ifdef BCACHEFS_FUSE
	PKGCONFIG_LIBS+="fuse3 >= 3.7"
	CFLAGS+=-DBCACHEFS_FUSE
endif

PKGCONFIG_CFLAGS:=$(shell $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_CFLAGS))
    $(error pkg-config error, command: $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
endif
PKGCONFIG_LDLIBS:=$(shell $(PKG_CONFIG) --libs   $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_LDLIBS))
    $(error pkg-config error, command: $(PKG_CONFIG) --libs $(PKGCONFIG_LIBS))
endif

CFLAGS+=$(PKGCONFIG_CFLAGS)
LDLIBS+=$(PKGCONFIG_LDLIBS)

LDLIBS+=-lm -lpthread -lrt -lscrypt -lkeyutils -laio -ldl
LDLIBS+=$(EXTRA_LDLIBS)

ifeq ($(PREFIX),/usr)
	ROOT_SBINDIR=/sbin
	INITRAMFS_DIR=$(PREFIX)/share/initramfs-tools
else
	ROOT_SBINDIR=$(PREFIX)/sbin
	INITRAMFS_DIR=/etc/initramfs-tools
endif

.PHONY: all
all: bcachefs

.PHONY: tests
tests: tests/test_helper

.PHONY: check
check: tests bcachefs
	cd tests; $(PYTEST)

.PHONY: TAGS tags
TAGS:
	ctags -e -R .

tags:
	ctags -R .

SRCS=$(shell find . -type f -iname '*.c')
DEPS=$(SRCS:.c=.d)
-include $(DEPS)

OBJS=$(SRCS:.c=.o)
bcachefs: $(filter-out ./tests/%.o, $(OBJS))

MOUNT_SRCS=$(shell find mount/src -type f -iname '*.rs') \
    mount/Cargo.toml mount/Cargo.lock mount/build.rs
libbcachefs_mount.a: $(MOUNT_SRCS)
	LIBBCACHEFS_INCLUDE=$(CURDIR) cargo build --manifest-path mount/Cargo.toml --release
	cp mount/target/release/libbcachefs_mount.a $@

MOUNT_OBJ=$(filter-out ./bcachefs.o ./tests/%.o ./cmd_%.o , $(OBJS))
mount.bcachefs: libbcachefs_mount.a $(MOUNT_OBJ)
	$(CC) -Wl,--gc-sections libbcachefs_mount.a $(MOUNT_OBJ) -o $@ $(LDLIBS)

tests/test_helper: $(filter ./tests/%.o, $(OBJS))

# If the version string differs from the last build, update the last version
ifneq ($(VERSION),$(shell cat .version 2>/dev/null))
.PHONY: .version
endif
.version:
	echo '$(VERSION)' > $@

# Rebuild the 'version' command any time the version string changes
cmd_version.o : .version

doc/bcachefs.5: doc/bcachefs.5.txt
	a2x -f manpage doc/bcachefs.5.txt

.PHONY: install
install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
install: bcachefs
	$(INSTALL) -m0755 -D bcachefs      -t $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0755    fsck.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0755    mkfs.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0644 -D bcachefs.8    -t $(DESTDIR)$(PREFIX)/share/man/man8/
	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
	$(INSTALL) -m0755 -D mount.bcachefs.sh $(DESTDIR)$(ROOT_SBINDIR)
	sed -i '/^# Note: make install replaces/,$$d' $(DESTDIR)$(INITRAMFS_HOOK)
	echo "copy_exec $(ROOT_SBINDIR)/bcachefs /sbin/bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)

.PHONY: clean
clean:
	$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version $(OBJS) $(DEPS)
	$(RM) -rf mount/target

.PHONY: deb
deb: all
# --unsigned-source --unsigned-changes --no-pre-clean --build=binary
# --diff-ignore --tar-ignore
	debuild -us -uc -nc -b -i -I

.PHONE: update-bcachefs-sources
update-bcachefs-sources:
	git rm -rf --ignore-unmatch libbcachefs
	test -d libbcachefs || mkdir libbcachefs
	cp $(LINUX_DIR)/fs/bcachefs/*.[ch] libbcachefs/
	git add libbcachefs/*.[ch]
	cp $(LINUX_DIR)/include/trace/events/bcachefs.h include/trace/events/
	git add include/trace/events/bcachefs.h
	cp $(LINUX_DIR)/kernel/locking/six.c linux/
	git add linux/six.c
	cp $(LINUX_DIR)/include/linux/six.h include/linux/
	git add include/linux/six.h
	$(RM) libbcachefs/*.mod.c
	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
	git add .bcachefs_revision

.PHONE: update-commit-bcachefs-sources
update-commit-bcachefs-sources: update-bcachefs-sources
	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

## bcachefs-tools 0.1%2Bgit20210805.6c42566

=== debian/changelog ===
bcachefs-tools (0.1+git20210805.6c42566-2ubuntu1) jammy; urgency=medium

  * Disable LTO on amd64, as this runs us out of memory on the autobuilders.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Jan 2022 22:53:21 +0000

bcachefs-tools (0.1+git20210805.6c42566-2) unstable; urgency=medium

  * Remove valgrind as build-dependency, seems unneeded unless
    doing debug work and is not available on all architectures.

 -- Jonathan Carter <jcc@debian.org>  Fri, 03 Sep 2021 16:07:11 +0200

bcachefs-tools (0.1+git20210805.6c42566-1) unstable; urgency=medium

  * New upstream snapshot
  * Update standards version to 4.6.0
  * Add python3-docutils as dependency
  * Do not run tests at package build time

 -- Jonathan Carter <jcc@debian.org>  Tue, 06 Apr 2021 15:11:27 +0200

bcachefs-tools (0.1+git20201025.742dbbdb-1) unstable; urgency=medium

  * New upstream snapshot

 -- Jonathan Carter <jcc@debian.org>  Mon, 26 Oct 2020 08:45:37 +0200

bcachefs-tools (0.1+git20201017.8a4408-1~exp1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper-compat to 13
  * Update standards version to 4.5.0
  * Declare Rules-Requires-Root: no
  * debian/copyright:
    - Update copyright years
    - Update copyright owners
    - Add intel and ccan copyright
  * Add build-dep on libudev-dev, python3-pytest  and valgrind

 -- Jonathan Carter <jcc@debian.org>  Sun, 18 Oct 2020 17:29:27 +0200

bcachefs-tools (0.1+git20190829.aa2a42b-1~exp1) experimental; urgency=medium

  * Initial Release (Closes: #935178)

 -- Jonathan Carter <jcc@debian.org>  Mon, 16 Sep 2019 10:36:04 +0000

=== debian/control ===
Source: bcachefs-tools
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Carter <jcc@debian.org>
Section: utils
Priority: optional
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               python3-docutils,
               python3-pytest,
               libaio-dev,
               libfuse3-dev,
               libblkid-dev,
               libkeyutils-dev,
               liblz4-dev,
               libscrypt-dev,
               libsodium-dev,
               libudev-dev,
               liburcu-dev,
               libzstd-dev,
               uuid-dev,
               zlib1g-dev
Homepage: https://bcachefs.org/
Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools

Package: bcachefs-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: initramfs-tools | linux-initramfs-tool
Description: bcachefs userspace tools
 Userspace tools for bcachefs, a modern copy on write, checksumming, multi
 device filesystem.
 .
 Note: The current Debian kernels do not come with bcachefs support, you
 will have to use your own kernel or one provided by a 3rd party that
 contains bcachefs support.

## bcachefs-tools 0.1+git20201025.742dbbdb

=== debian/control ===
Source: bcachefs-tools
Maintainer: Jonathan Carter <jcc@debian.org>
Section: utils
Priority: optional
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               python3-pytest,
	       libaio-dev,
	       libblkid-dev,
	       libkeyutils-dev,
	       liblz4-dev,
	       libscrypt-dev,
	       libsodium-dev,
               libudev-dev,
	       liburcu-dev,
	       libzstd-dev,
	       uuid-dev,
               valgrind,
	       zlib1g-dev
Homepage: https://bcachefs.org/
Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools

Package: bcachefs-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: initramfs-tools | linux-initramfs-tool
Description: bcachefs userspace tools
 Userspace tools for bcachefs, a modern copy on write, checksumming, multi
 device filesystem.
 .
 Note: The current Debian kernels do not come with bcachefs support, you
 will have to use your own kernel or one provided by a 3rd party that
 contains bcachefs support.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
PREFIX := /usr

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- "PREFIX=$(PREFIX)"

override_dh_auto_clean:

## bcachefs-tools 0.1+git20210805.6c42566

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,9 @@
-
 PREFIX?=/usr/local
 PKG_CONFIG?=pkg-config
 INSTALL=install
 PYTEST=pytest-3
 CFLAGS+=-std=gnu89 -O2 -g -MMD -Wall				\
 	-Wno-pointer-sign					\
-	-Wno-zero-length-bounds					\
 	-fno-strict-aliasing					\
 	-fno-delete-null-pointer-checks				\
 	-I. -Iinclude -Iraid					\
@@ -24,21 +22,15 @@
 
 VERSION?=$(shell git describe --dirty=+ 2>/dev/null || echo v0.1-nogit)
 
-CC_VERSION=$(shell $(CC) -v 2>&1|grep -E '(gcc|clang) version')
+include Makefile.compiler
 
-ifneq (,$(findstring gcc,$(CC_VERSION)))
-	CFLAGS+=-Wno-unused-but-set-variable
-endif
-
-ifneq (,$(findstring clang,$(CC_VERSION)))
-	CFLAGS+=-Wno-missing-braces
-endif
-
-ifdef D
-	CFLAGS+=-Werror
-	CFLAGS+=-DCONFIG_BCACHEFS_DEBUG=y
-endif
-	CFLAGS+=-DCONFIG_VALGRIND=y
+CFLAGS+=$(call cc-disable-warning, unused-but-set-variable)
+CFLAGS+=$(call cc-disable-warning, stringop-overflow)
+CFLAGS+=$(call cc-disable-warning, zero-length-bounds)
+CFLAGS+=$(call cc-disable-warning, missing-braces)
+CFLAGS+=$(call cc-disable-warning, zero-length-array)
+CFLAGS+=$(call cc-disable-warning, shift-overflow)
+CFLAGS+=$(call cc-disable-warning, enum-conversion)
 
 PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev"
 ifdef BCACHEFS_FUSE
@@ -69,8 +61,24 @@
 	INITRAMFS_DIR=/etc/initramfs-tools
 endif
 
+var := $(shell rst2man -V 2>/dev/null)
+ifeq ($(.SHELLSTATUS),0)
+	RST2MAN=rst2man
+endif
+
+var := $(shell rst2man.py -V 2>/dev/null)
+ifeq ($(.SHELLSTATUS),0)
+	RST2MAN=rst2man.py
+endif
+
+undefine var
+
+ifeq (,$(RST2MAN))
+	@echo "WARNING: no RST2MAN found!"
+endif
+
 .PHONY: all
-all: bcachefs
+all: bcachefs bcachefs.5
 
 .PHONY: tests
 tests: tests/test_helper
@@ -86,6 +94,14 @@
 tags:
 	ctags -R .
 
+DOCSRC := opts_macro.h bcachefs.5.rst.tmpl
+DOCGENERATED := bcachefs.5 doc/bcachefs.5.rst
+DOCDEPS := $(addprefix ./doc/,$(DOCSRC))
+bcachefs.5: $(DOCDEPS)  libbcachefs/opts.h
+	$(CC) doc/opts_macro.h -I libbcachefs -I include -E 2>/dev/null	\
+		| doc/macro2rst.py
+	$(RST2MAN) doc/bcachefs.5.rst bcachefs.5
+
 SRCS=$(shell find . -type f -iname '*.c')
 DEPS=$(SRCS:.c=.d)
 -include $(DEPS)
@@ -95,6 +111,10 @@
 
 MOUNT_SRCS=$(shell find mount/src -type f -iname '*.rs') \
     mount/Cargo.toml mount/Cargo.lock mount/build.rs
+
+debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
+debug: bcachefs
+
 libbcachefs_mount.a: $(MOUNT_SRCS)
 	LIBBCACHEFS_INCLUDE=$(CURDIR) cargo build --manifest-path mount/Cargo.toml --release
 	cp mount/target/release/libbcachefs_mount.a $@
@@ -115,9 +135,6 @@
 # Rebuild the 'version' command any time the version string changes
 cmd_version.o : .version
 
-doc/bcachefs.5: doc/bcachefs.5.txt
-	a2x -f manpage doc/bcachefs.5.txt
-
 .PHONY: install
 install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
 install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
@@ -134,16 +151,14 @@
 
 .PHONY: clean
 clean:
-	$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version $(OBJS) $(DEPS)
+	$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version $(OBJS) $(DEPS) $(DOCGENERATED)
 	$(RM) -rf mount/target
 
 .PHONY: deb
 deb: all
-# --unsigned-source --unsigned-changes --no-pre-clean --build=binary
-# --diff-ignore --tar-ignore
 	debuild -us -uc -nc -b -i -I
 
-.PHONE: update-bcachefs-sources
+.PHONY: update-bcachefs-sources
 update-bcachefs-sources:
 	git rm -rf --ignore-unmatch libbcachefs
 	test -d libbcachefs || mkdir libbcachefs
@@ -151,14 +166,24 @@
 	git add libbcachefs/*.[ch]
 	cp $(LINUX_DIR)/include/trace/events/bcachefs.h include/trace/events/
 	git add include/trace/events/bcachefs.h
+	cp $(LINUX_DIR)/include/linux/xxhash.h include/linux/
+	git add include/linux/xxhash.h
+	cp $(LINUX_DIR)/lib/xxhash.c linux/
+	git add linux/xxhash.c
 	cp $(LINUX_DIR)/kernel/locking/six.c linux/
 	git add linux/six.c
 	cp $(LINUX_DIR)/include/linux/six.h include/linux/
 	git add include/linux/six.h
+	cp $(LINUX_DIR)/include/linux/list_nulls.h include/linux/
+	git add include/linux/list_nulls.h
+	cp $(LINUX_DIR)/include/linux/poison.h include/linux/
+	git add include/linux/poison.h
+	cp $(LINUX_DIR)/scripts/Makefile.compiler ./
+	git add Makefile.compiler
 	$(RM) libbcachefs/*.mod.c
 	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
 	git add .bcachefs_revision
 
-.PHONE: update-commit-bcachefs-sources
+.PHONY: update-commit-bcachefs-sources
 update-commit-bcachefs-sources: update-bcachefs-sources
 	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,13 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
+ifeq ($(DEB_BUILD_ARCH),amd64)
+    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
+endif
+
 PREFIX := /usr
 
 %:
@@ -11,3 +18,4 @@
 
 override_dh_auto_clean:
 
+override_dh_auto_test:

## bcachefs-tools 0.1+git20220216.a1e928a

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 PREFIX?=/usr/local
 PKG_CONFIG?=pkg-config
 INSTALL=install
-PYTEST=pytest-3
-CFLAGS+=-std=gnu89 -O2 -g -MMD -Wall				\
+
+CFLAGS+=-std=gnu89 -O2 -g -MMD -Wall -fPIC				\
 	-Wno-pointer-sign					\
 	-fno-strict-aliasing					\
 	-fno-delete-null-pointer-checks				\
@@ -20,6 +20,21 @@
 	$(EXTRA_CFLAGS)
 LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)
 
+## Configure Tools
+PYTEST_ARGS?=
+PYTEST_CMD?=$(shell \
+	command -v pytest-3 \
+	|| which pytest-3 \
+)
+PYTEST:=$(PYTEST_CMD) $(PYTEST_ARGS)
+
+CARGO_ARGS=
+CARGO=cargo $(CARGO_ARGS)
+CARGO_PROFILE=release
+# CARGO_PROFILE=debug
+
+CARGO_BUILD_ARGS=--$(CARGO_PROFILE)
+CARGO_BUILD=$(CARGO) build $(CARGO_BUILD_ARGS)
 VERSION?=$(shell git describe --dirty=+ 2>/dev/null || echo v0.1-nogit)
 
 include Makefile.compiler
@@ -49,8 +64,7 @@
 
 CFLAGS+=$(PKGCONFIG_CFLAGS)
 LDLIBS+=$(PKGCONFIG_LDLIBS)
-
-LDLIBS+=-lm -lpthread -lrt -lscrypt -lkeyutils -laio -ldl
+LDLIBS+=-lm -lpthread -lrt -lkeyutils -laio -ldl
 LDLIBS+=$(EXTRA_LDLIBS)
 
 ifeq ($(PREFIX),/usr)
@@ -61,31 +75,22 @@
 	INITRAMFS_DIR=/etc/initramfs-tools
 endif
 
-var := $(shell rst2man -V 2>/dev/null)
-ifeq ($(.SHELLSTATUS),0)
-	RST2MAN=rst2man
-endif
-
-var := $(shell rst2man.py -V 2>/dev/null)
-ifeq ($(.SHELLSTATUS),0)
-	RST2MAN=rst2man.py
-endif
-
-undefine var
-
-ifeq (,$(RST2MAN))
-	@echo "WARNING: no RST2MAN found!"
-endif
-
 .PHONY: all
-all: bcachefs bcachefs.5
+all: bcachefs lib
+
+.PHONY: lib
+lib: libbcachefs.so
 
 .PHONY: tests
 tests: tests/test_helper
 
 .PHONY: check
 check: tests bcachefs
-	cd tests; $(PYTEST)
+ifneq (,$(PYTEST_CMD))
+	$(PYTEST)
+else
+	@echo "WARNING: pytest not found or specified, tests could not be run."
+endif
 
 .PHONY: TAGS tags
 TAGS:
@@ -94,34 +99,32 @@
 tags:
 	ctags -R .
 
-DOCSRC := opts_macro.h bcachefs.5.rst.tmpl
-DOCGENERATED := bcachefs.5 doc/bcachefs.5.rst
-DOCDEPS := $(addprefix ./doc/,$(DOCSRC))
-bcachefs.5: $(DOCDEPS)  libbcachefs/opts.h
-	$(CC) doc/opts_macro.h -I libbcachefs -I include -E 2>/dev/null	\
-		| doc/macro2rst.py
-	$(RST2MAN) doc/bcachefs.5.rst bcachefs.5
-
-SRCS=$(shell find . -type f -iname '*.c')
+SRCS=$(shell find . -type f ! -path '*/.*/*' -iname '*.c')
 DEPS=$(SRCS:.c=.d)
 -include $(DEPS)
 
 OBJS=$(SRCS:.c=.o)
 bcachefs: $(filter-out ./tests/%.o, $(OBJS))
 
-MOUNT_SRCS=$(shell find mount/src -type f -iname '*.rs') \
-    mount/Cargo.toml mount/Cargo.lock mount/build.rs
+RUST_SRCS=$(shell find rust-src/ -type f -iname '*.rs')
+MOUNT_SRCS=$(filter %mount, $(RUST_SRCS))
 
 debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
 debug: bcachefs
 
-libbcachefs_mount.a: $(MOUNT_SRCS)
-	LIBBCACHEFS_INCLUDE=$(CURDIR) cargo build --manifest-path mount/Cargo.toml --release
-	cp mount/target/release/libbcachefs_mount.a $@
-
 MOUNT_OBJ=$(filter-out ./bcachefs.o ./tests/%.o ./cmd_%.o , $(OBJS))
-mount.bcachefs: libbcachefs_mount.a $(MOUNT_OBJ)
-	$(CC) -Wl,--gc-sections libbcachefs_mount.a $(MOUNT_OBJ) -o $@ $(LDLIBS)
+libbcachefs.so: LDFLAGS+=-shared
+libbcachefs.so: $(MOUNT_OBJ)
+	$(CC) $(LDFLAGS) $+ -o $@ $(LDLIBS)
+
+MOUNT_TOML=rust-src/mount/Cargo.toml
+mount.bcachefs: lib $(MOUNT_SRCS)
+	LIBBCACHEFS_LIB=$(CURDIR) \
+	LIBBCACHEFS_INCLUDE=$(CURDIR) \
+	$(CARGO_BUILD) --manifest-path $(MOUNT_TOML)
+
+	ln -f rust-src/mount/target/$(CARGO_PROFILE)/bcachefs-mount $@
+
 
 tests/test_helper: $(filter ./tests/%.o, $(OBJS))
 
@@ -138,7 +141,7 @@
 .PHONY: install
 install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
 install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
-install: bcachefs
+install: bcachefs lib
 	$(INSTALL) -m0755 -D bcachefs      -t $(DESTDIR)$(ROOT_SBINDIR)
 	$(INSTALL) -m0755    fsck.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
 	$(INSTALL) -m0755    mkfs.bcachefs    $(DESTDIR)$(ROOT_SBINDIR)
@@ -146,17 +149,25 @@
 	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
 	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
 	$(INSTALL) -m0755 -D mount.bcachefs.sh $(DESTDIR)$(ROOT_SBINDIR)
+	$(INSTALL) -m0755 -D libbcachefs.so -t $(DESTDIR)$(PREFIX)/lib/
+
 	sed -i '/^# Note: make install replaces/,$$d' $(DESTDIR)$(INITRAMFS_HOOK)
 	echo "copy_exec $(ROOT_SBINDIR)/bcachefs /sbin/bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)
 
 .PHONY: clean
 clean:
 	$(RM) bcachefs mount.bcachefs libbcachefs_mount.a tests/test_helper .version $(OBJS) $(DEPS) $(DOCGENERATED)
-	$(RM) -rf mount/target
+	$(RM) -rf rust-src/*/target
 
 .PHONY: deb
 deb: all
 	debuild -us -uc -nc -b -i -I
+
+bcachefs-principles-of-operation.pdf: doc/bcachefs-principles-of-operation.tex
+	pdflatex doc/bcachefs-principles-of-operation.tex
+	pdflatex doc/bcachefs-principles-of-operation.tex
+
+doc: bcachefs-principles-of-operation.pdf
 
 .PHONY: update-bcachefs-sources
 update-bcachefs-sources:
@@ -184,6 +195,7 @@
 	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
 	git add .bcachefs_revision
 
+
 .PHONY: update-commit-bcachefs-sources
 update-commit-bcachefs-sources: update-bcachefs-sources
 	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

=== debian/changelog ===
bcachefs-tools (0.1+git20220216.a1e928a-1) unstable; urgency=medium

  * New upstream snapshot
  * Grab patch from Ubuntu to reduce memory on amd64 builders
    (http://launchpadlibrarian.net/580140160/bcachefs-tools_0.1+git20210805.6c42566-2_0.1+git20210805.6c42566-2ubuntu1.diff.gz)
  * Update copyright years

 -- Jonathan Carter <jcc@debian.org>  Wed, 16 Feb 2022 14:42:20 +0200

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,24 @@
 Maintainer: Jonathan Carter <jcc@debian.org>
 Section: utils
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                pkg-config,
+               python3-docutils,
                python3-pytest,
-	       libaio-dev,
-	       libblkid-dev,
-	       libkeyutils-dev,
-	       liblz4-dev,
-	       libscrypt-dev,
-	       libsodium-dev,
+               libaio-dev,
+               libfuse3-dev,
+               libblkid-dev,
+               libkeyutils-dev,
+               liblz4-dev,
+               libscrypt-dev,
+               libsodium-dev,
                libudev-dev,
-	       liburcu-dev,
-	       libzstd-dev,
-	       uuid-dev,
-               valgrind,
-	       zlib1g-dev
+               liburcu-dev,
+               libzstd-dev,
+               uuid-dev,
+               zlib1g-dev
 Homepage: https://bcachefs.org/
 Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
 Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools

=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,13 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+PREFIX := /usr
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 ifeq ($(DEB_BUILD_ARCH),amd64)
     DEB_BUILD_MAINT_OPTIONS += optimize=-lto
 endif
-
-PREFIX := /usr
 
 %:
 	dh $@

## bcachefs-tools 1.7.0

=== debian/changelog ===
bcachefs-tools (1:1.7.0-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1066929)
  * Bump epoch
    - Ack from pochu:
      https://lists.debian.org/msgid-search/1c5f86c9-1525-4d44-996f-3d4eed1e64d6@debian.org

 -- Jonathan Carter <jcc@debian.org>  Wed, 15 May 2024 12:04:38 +0200

bcachefs-tools (24+really1.7.0-1~exp1) experimental; urgency=medium

  [ Steinar H. Gunderson ]
  * New upstream release.
    * Remove the do-not-install-mount-symlink patch.
    * Add epoch to deal with new upstream versioning scheme,
      and disable pristine-tar option in gbp.conf, since there is no
      pristine-tar branch. (Closes: #1054620)
    * revert-bindgen-changes.patch: New patch, reinstates upstream
      hack that makes bcachefs-tools work with bindgen older than 0.69.4
      (which isn't in Debian yet).
  * Build-depend on systemd-dev, since udev.pc has moved there.
  * Enable Rust parts, including mount.bcachefs. (Closes: #1060256)
    * Include the right .mk flags to get DEB_HOST_RUST_TYPE etc., and
      export that (needed for Debian's cargo wrapper).
    * Override CARGO, and set CARGO_HOME during installation.
    * Run prepare-debian in dh_auto_configure, and clean up the vendor dir
      in dh_auto_clean.
    * Remove Cargo.lock before the build, so that we can use Debian's versions
      of all Rust crates. Also remove it in dh_auto_clean, so that it does not
      take a diff.
    * revert-bindgen-changes.patch: New patch, loosen required versions
      of Rust crates
      - errno (0.2 -> >= 0.2, < 1; Debian has 0.4)
      - udev (0.7 -> >= 0.7, < 1; Debian has 0.8)
      - memoffset (0.8.0 -> 0.6; Debian has 0.6.5, so a downgrade)
      - paste (1.0.11 -> 1.0; Debian has 1.0.8, so a downgrade)
      - bindgen (0.69.4 -> 0.66; see revert-bindgen-changes.patch above)
    * Add build-dependency on all relevant Rust crates, and on python3:native
      due to use of the Cargo wrapper.
  * Build-Depend on pkgconf instead of pkg-config (Lintian warning).
  * Add debhelper tokens to postinst and postrm scripts (Lintian warning).
  * Depend on python3:any due to bcachefsck_all being a Python script
    (Lintian warning).

  [ Jonathan Carter ]
  * Upload to experimental
  * Add librust-chrono-dev, librust-getset-dev and
    librust-gag-dev to build-depends
  * Recreate dependencies patch to match new upstream source
  * Update standards version to 4.7.0
  * Update above mentioned revert-bindgen-changes.patch

 -- Jonathan Carter <jcc@debian.org>  Thu, 25 Apr 2024 13:53:55 +0200

bcachefs-tools (24+really1.3.4-2) unstable; urgency=medium

  * Upload to unstable 

 -- Jonathan Carter <jcc@debian.org>  Wed, 03 Jan 2024 17:06:16 +0200

bcachefs-tools (24+really1.3.4-2~exp1) experimental; urgency=medium

  [ Chris Hofstaedtler ]
  * Non-maintainer upload.
  * Install files into /usr instead of /. (Closes: #1059373)

  [ Jonathan Carter ]
  * Do not install bcachefs.mount symlink (Closes: #1057295) 

 -- Jonathan Carter <jcc@debian.org>  Wed, 27 Dec 2023 19:22:06 +0200

bcachefs-tools (24+really1.3.4-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 21 Nov 2023 17:26:13 +0200

bcachefs-tools (24+really1.2-1) unstable; urgency=medium

  * New upstream release (Closes: #1054613)
  * Disable new rust build
    (dependencies currently unavailable in Debian, see debian/README.todo)
  * Remove unneeded override_dh_auto_clean from debian/rules
    (Closes: #1043654)

 -- Jonathan Carter <jcc@debian.org>  Thu, 28 Sep 2023 19:54:47 +0200

bcachefs-tools (24-1) unstable; urgency=medium

  * New upstream release 

 -- Jonathan Carter <jcc@debian.org>  Tue, 29 Nov 2022 09:40:27 +0200

bcachefs-tools (23-1) unstable; urgency=medium

  * New upstream release
  * Update standards version to 4.6.1

 -- Jonathan Carter <jcc@debian.org>  Mon, 31 Oct 2022 11:45:25 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,12 @@
 Maintainer: Jonathan Carter <jcc@debian.org>
 Section: utils
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               pkg-config,
+               cargo,
+               python3:native,
+               pkgconf,
                python3-docutils,
                python3-pytest,
                libaio-dev,
@@ -18,15 +20,44 @@
                libudev-dev,
                liburcu-dev,
                libzstd-dev,
+               systemd-dev,
                uuid-dev,
-               zlib1g-dev
+               zlib1g-dev,
+#              -- Cargo.toml
+               librust-atty-0.2-dev (>= 0.2.14-~~),
+               librust-log-0.4-dev,
+               librust-log-0+std-dev,
+               librust-colored-2-dev,
+               librust-clap-4-dev (>= 4.0.32-~~),
+               librust-clap-4+derive-dev,
+               librust-clap-4+wrap-help-dev,
+               librust-clap-complete-4-dev (>= 4.3.2-~~),
+	       librust-chrono-dev,
+	       librust-gag-dev,
+	       librust-getset-dev,
+               librust-anyhow-1.0-dev,
+               librust-libc-0.2-dev,
+               librust-udev-0-dev (>= 0.7-~~),
+               librust-uuid-1-dev (>= 1.2.2-~~),
+               librust-errno-0-dev (>= 0.2),
+               librust-either-1-dev (>= 1.5),
+               librust-rpassword-7-dev,
+               librust-byteorder-1-dev (>= 1.3),
+#              -- bch_bindgen/Cargo.toml
+#              anyhow, uuid, byteorder are covered above
+               librust-bitfield-0-dev (>= 0.14.0-~~),
+               librust-memoffset-0.6-dev,
+               librust-bitflags-1-dev (>= 1.3.2-~~),
+               librust-paste-1.0-dev,
+               librust-pkg-config-0.3-dev,
+               librust-bindgen-0.66-dev
 Homepage: https://bcachefs.org/
 Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
 Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools
 
 Package: bcachefs-tools
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3:any
 Recommends: initramfs-tools | linux-initramfs-tool
 Description: bcachefs userspace tools
  Userspace tools for bcachefs, a modern copy on write, checksumming, multi

## bcachefs-tools 1.9.1

=== Makefile ===
VERSION=1.9.1

PREFIX?=/usr/local
LIBEXECDIR?=$(PREFIX)/libexec
PKG_CONFIG?=pkg-config
INSTALL=install
LN=ln
.DEFAULT_GOAL=all

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
  CARGO_CLEAN_ARGS = --verbose
else
  Q = @
  CARGO_CLEAN_ARGS = --quiet
endif

# Prevent recursive expansions of $(CFLAGS) to avoid repeatedly performing
# compile tests
CFLAGS:=$(CFLAGS)

CFLAGS+=-std=gnu11 -O2 -g -MMD -Wall -fPIC			\
	-Wno-pointer-sign					\
	-Wno-deprecated-declarations				\
	-fno-strict-aliasing					\
	-fno-delete-null-pointer-checks				\
	-I. -Ic_src -Iinclude -Iraid				\
	-D_FILE_OFFSET_BITS=64					\
	-D_GNU_SOURCE						\
	-D_LGPL_SOURCE						\
	-DRCU_MEMBARRIER					\
	-DZSTD_STATIC_LINKING_ONLY				\
	-DFUSE_USE_VERSION=35					\
	-DNO_BCACHEFS_CHARDEV					\
	-DNO_BCACHEFS_FS					\
	-DNO_BCACHEFS_SYSFS					\
	-DVERSION_STRING='"$(VERSION)"'				\
	-D__SANE_USERSPACE_TYPES__				\
	$(EXTRA_CFLAGS)

# Intenionally not doing the above to $(LDFLAGS) because we rely on
# recursive expansion here (CFLAGS is not yet completely built by this line)
LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)

ifdef CARGO_TOOLCHAIN_VERSION
  CARGO_TOOLCHAIN = +$(CARGO_TOOLCHAIN_VERSION)
endif

CARGO_ARGS=${CARGO_TOOLCHAIN}
CARGO=cargo $(CARGO_ARGS)
CARGO_PROFILE=release
# CARGO_PROFILE=debug

CARGO_BUILD_ARGS=--$(CARGO_PROFILE)
CARGO_BUILD=$(CARGO) build $(CARGO_BUILD_ARGS)

CARGO_CLEAN=$(CARGO) clean $(CARGO_CLEAN_ARGS)

include Makefile.compiler

CFLAGS+=$(call cc-disable-warning, unused-but-set-variable)
CFLAGS+=$(call cc-disable-warning, stringop-overflow)
CFLAGS+=$(call cc-disable-warning, zero-length-bounds)
CFLAGS+=$(call cc-disable-warning, missing-braces)
CFLAGS+=$(call cc-disable-warning, zero-length-array)
CFLAGS+=$(call cc-disable-warning, shift-overflow)
CFLAGS+=$(call cc-disable-warning, enum-conversion)
CFLAGS+=$(call cc-disable-warning, gnu-variable-sized-type-not-at-end)

PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev libkeyutils udev"
ifdef BCACHEFS_FUSE
	PKGCONFIG_LIBS+="fuse3 >= 3.7"
	CFLAGS+=-DBCACHEFS_FUSE
	export RUSTFLAGS=--cfg fuse
endif

PKGCONFIG_CFLAGS:=$(shell $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_CFLAGS))
    $(error pkg-config error, command: $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
endif
PKGCONFIG_LDLIBS:=$(shell $(PKG_CONFIG) --libs   $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_LDLIBS))
    $(error pkg-config error, command: $(PKG_CONFIG) --libs $(PKGCONFIG_LIBS))
endif
PKGCONFIG_UDEVDIR:=$(shell $(PKG_CONFIG) --variable=udevdir udev)
ifeq (,$(PKGCONFIG_UDEVDIR))
    $(error pkg-config error, command: $(PKG_CONFIG) --variable=udevdir udev)
endif
PKGCONFIG_UDEVRULESDIR:=$(PKGCONFIG_UDEVDIR)/rules.d

CFLAGS+=$(PKGCONFIG_CFLAGS)
LDLIBS+=$(PKGCONFIG_LDLIBS)
LDLIBS+=-lm -lpthread -lrt -lkeyutils -laio -ldl
LDLIBS+=$(EXTRA_LDLIBS)

ifeq ($(PREFIX),/usr)
	ROOT_SBINDIR?=/sbin
	INITRAMFS_DIR=$(PREFIX)/share/initramfs-tools
else
	ROOT_SBINDIR?=$(PREFIX)/sbin
	INITRAMFS_DIR=/etc/initramfs-tools
endif

PKGCONFIG_SERVICEDIR:=$(shell $(PKG_CONFIG) --variable=systemdsystemunitdir systemd)
ifeq (,$(PKGCONFIG_SERVICEDIR))
  $(warning skipping systemd integration)
else
BCACHEFSCK_ARGS=-f -n
systemd_libexecfiles=\
	fsck/bcachefsck_fail \
	fsck/bcachefsck_all

systemd_services=\
	fsck/bcachefsck_fail@.service \
	fsck/bcachefsck@.service \
	fsck/system-bcachefsck.slice \
	fsck/bcachefsck_all_fail.service \
	fsck/bcachefsck_all.service \
	fsck/bcachefsck_all.timer

built_scripts+=\
	fsck/bcachefsck_fail@.service \
	fsck/bcachefsck@.service \
	fsck/bcachefsck_all_fail.service \
	fsck/bcachefsck_all \
	fsck/bcachefsck_all.service

%.service: %.service.in
	@echo "    [SED]    $@"
	$(Q)sed -e "s|@libexecdir@|$(LIBEXECDIR)|g" \
	        -e "s|@bcachefsck_args@|$(BCACHEFSCK_ARGS)|g" < $< > $@

fsck/bcachefsck_all: fsck/bcachefsck_all.in
	@echo "    [SED]    $@"
	$(Q)sed -e "s|@bcachefsck_args@|$(BCACHEFSCK_ARGS)|g" < $< > $@

optional_build+=$(systemd_libexecfiles) $(systemd_services)
optional_install+=install_systemd
endif	# PKGCONFIG_SERVICEDIR

.PHONY: all
all: bcachefs $(optional_build)

.PHONY: debug
debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
debug: bcachefs

.PHONY: tests
tests: tests/test_helper

.PHONY: TAGS tags
TAGS:
	ctags -e -R .

tags:
	ctags -R .

SRCS:=$(sort $(shell find . -type f ! -path '*/.*/*' -iname '*.c'))
DEPS:=$(SRCS:.c=.d)
-include $(DEPS)

OBJS:=$(SRCS:.c=.o)

%.o: %.c
	@echo "    [CC]     $@"
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

BCACHEFS_DEPS=libbcachefs.a
RUST_SRCS:=$(shell find src bch_bindgen/src -type f -iname '*.rs')

bcachefs: $(BCACHEFS_DEPS) $(RUST_SRCS)
	$(Q)$(CARGO_BUILD)

libbcachefs.a: $(filter-out ./tests/%.o, $(OBJS))
	@echo "    [AR]     $@"
	$(Q)ar -rc $@ $+

tests/test_helper: $(filter ./tests/%.o, $(OBJS))
	@echo "    [LD]     $@"
	$(Q)$(CC) $(LDFLAGS) $+ $(LOADLIBES) $(LDLIBS) -o $@

# If the version string differs from the last build, update the last version
ifneq ($(VERSION),$(shell cat .version 2>/dev/null))
.PHONY: .version
endif
.version:
	@echo "  [VERS]    $@"
	$(Q)echo '$(VERSION)' > $@

# Rebuild the 'version' command any time the version string changes
cmd_version.o : .version

.PHONY: install
install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
install: bcachefs $(optional_install)
	$(INSTALL) -m0755 -D target/release/bcachefs -t $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0644 -D bcachefs.8    -t $(DESTDIR)$(PREFIX)/share/man/man8/
	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
	$(INSTALL) -m0644 -D udev/64-bcachefs.rules -t $(DESTDIR)$(PKGCONFIG_UDEVRULESDIR)/
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.fuse.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.fuse.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.fuse.bcachefs

	sed -i '/^# Note: make install replaces/,$$d' $(DESTDIR)$(INITRAMFS_HOOK)
	echo "copy_exec $(ROOT_SBINDIR)/bcachefs /sbin/bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)
	echo "copy_exec $(ROOT_SBINDIR)/mount.bcachefs /sbin/mount.bcachefs" >> $(DESTDIR)$(INITRAMFS_HOOK)

.PHONY: install_systemd
install_systemd: $(systemd_services) $(systemd_libexecfiles)
	$(INSTALL) -m0755 -D $(systemd_libexecfiles) -t $(DESTDIR)$(LIBEXECDIR)
	$(INSTALL) -m0644 -D $(systemd_services) -t $(DESTDIR)$(PKGCONFIG_SERVICEDIR)

.PHONY: clean
clean:
	@echo "Cleaning all"
	$(Q)$(RM) libbcachefs.a c_src/libbcachefs.a tests/test_helper .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
	$(Q)$(CARGO_CLEAN)
	$(Q)$(RM) -f $(built_scripts)

.PHONY: deb
deb: all
	debuild -us -uc -nc -b -i -I

.PHONY: rpm
rpm: clean
	rpmbuild --build-in-place -bb --define "_version $(subst -,_,$(VERSION))" packaging/bcachefs-tools.spec

bcachefs-principles-of-operation.pdf: doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex

doc: bcachefs-principles-of-operation.pdf

.PHONY: cargo-update-msrv
cargo-update-msrv:
	cargo +nightly generate-lockfile -Zmsrv-policy
	cargo +nightly generate-lockfile --manifest-path bch_bindgen/Cargo.toml -Zmsrv-policy

.PHONY: update-bcachefs-sources
update-bcachefs-sources:
	git rm -rf --ignore-unmatch libbcachefs
	test -d libbcachefs || mkdir libbcachefs
	cp $(LINUX_DIR)/fs/bcachefs/*.[ch] libbcachefs/
	git add libbcachefs/*.[ch]
	git rm -f libbcachefs/mean_and_variance_test.c
	cp $(LINUX_DIR)/include/linux/closure.h include/linux/
	git add include/linux/closure.h
	cp $(LINUX_DIR)/lib/closure.c linux/
	git add linux/closure.c
	cp $(LINUX_DIR)/include/linux/xxhash.h include/linux/
	git add include/linux/xxhash.h
	cp $(LINUX_DIR)/lib/xxhash.c linux/
	git add linux/xxhash.c
	cp $(LINUX_DIR)/include/linux/list_nulls.h include/linux/
	git add include/linux/list_nulls.h
	cp $(LINUX_DIR)/include/linux/poison.h include/linux/
	git add include/linux/poison.h
	cp $(LINUX_DIR)/include/linux/generic-radix-tree.h include/linux/
	git add include/linux/generic-radix-tree.h
	cp $(LINUX_DIR)/lib/generic-radix-tree.c linux/
	git add linux/generic-radix-tree.c
	cp $(LINUX_DIR)/include/linux/kmemleak.h include/linux/
	git add include/linux/kmemleak.h
	cp $(LINUX_DIR)/lib/math/int_sqrt.c linux/
	git add linux/int_sqrt.c
	cp $(LINUX_DIR)/scripts/Makefile.compiler ./
	git add Makefile.compiler
	$(RM) libbcachefs/*.mod.c
	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
	git add .bcachefs_revision


.PHONY: update-commit-bcachefs-sources
update-commit-bcachefs-sources: update-bcachefs-sources
	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

SRCTARXZ = bcachefs-tools-$(VERSION).tar.xz
SRCDIR=bcachefs-tools-$(VERSION)

.PHONY: tarball
tarball: $(SRCTARXZ)

$(SRCTARXZ) : .gitcensus
	$(Q)tar --transform "s,^,$(SRCDIR)/," -Jcf $(SRCDIR).tar.xz  \
	    `cat .gitcensus` 
	@echo Wrote: $@

.PHONY: .gitcensus
.gitcensus:
	$(Q)if test -d .git; then \
	  git ls-files > .gitcensus; \
	fi

=== debian/control ===
--- 
+++ 
@@ -43,6 +43,7 @@
                librust-either-1-dev (>= 1.5),
                librust-rpassword-7-dev,
                librust-byteorder-1-dev (>= 1.3),
+	       librust-strum-dev (>= 0.26),
 #              -- bch_bindgen/Cargo.toml
 #              anyhow, uuid, byteorder are covered above
                librust-bitfield-0-dev (>= 0.14.0-~~),

## bcachefs-tools 1.9.4

=== Makefile ===
--- 
+++ 
@@ -180,7 +180,7 @@
 
 libbcachefs.a: $(filter-out ./tests/%.o, $(OBJS))
 	@echo "    [AR]     $@"
-	$(Q)ar -rc $@ $+
+	$(Q)$(AR) -rc $@ $+
 
 tests/test_helper: $(filter ./tests/%.o, $(OBJS))
 	@echo "    [LD]     $@"

## bcachefs-tools 1.13.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=1.9.1
+VERSION=1.12.0
 
 PREFIX?=/usr/local
 LIBEXECDIR?=$(PREFIX)/libexec
@@ -74,7 +74,7 @@
 CFLAGS+=$(call cc-disable-warning, enum-conversion)
 CFLAGS+=$(call cc-disable-warning, gnu-variable-sized-type-not-at-end)
 
-PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev libkeyutils udev"
+PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev libkeyutils"
 ifdef BCACHEFS_FUSE
 	PKGCONFIG_LIBS+="fuse3 >= 3.7"
 	CFLAGS+=-DBCACHEFS_FUSE
@@ -152,9 +152,6 @@
 debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
 debug: bcachefs
 
-.PHONY: tests
-tests: tests/test_helper
-
 .PHONY: TAGS tags
 TAGS:
 	ctags -e -R .
@@ -178,13 +175,9 @@
 bcachefs: $(BCACHEFS_DEPS) $(RUST_SRCS)
 	$(Q)$(CARGO_BUILD)
 
-libbcachefs.a: $(filter-out ./tests/%.o, $(OBJS))
+libbcachefs.a: $(OBJS)
 	@echo "    [AR]     $@"
 	$(Q)$(AR) -rc $@ $+
-
-tests/test_helper: $(filter ./tests/%.o, $(OBJS))
-	@echo "    [LD]     $@"
-	$(Q)$(CC) $(LDFLAGS) $+ $(LOADLIBES) $(LDLIBS) -o $@
 
 # If the version string differs from the last build, update the last version
 ifneq ($(VERSION),$(shell cat .version 2>/dev/null))
@@ -225,7 +218,7 @@
 .PHONY: clean
 clean:
 	@echo "Cleaning all"
-	$(Q)$(RM) libbcachefs.a c_src/libbcachefs.a tests/test_helper .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
+	$(Q)$(RM) libbcachefs.a c_src/libbcachefs.a .version *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
 	$(Q)$(CARGO_CLEAN)
 	$(Q)$(RM) -f $(built_scripts)
 
@@ -294,7 +287,7 @@
 
 $(SRCTARXZ) : .gitcensus
 	$(Q)tar --transform "s,^,$(SRCDIR)/," -Jcf $(SRCDIR).tar.xz  \
-	    `cat .gitcensus` 
+	    `cat .gitcensus`
 	@echo Wrote: $@
 
 .PHONY: .gitcensus

=== debian/changelog ===
bcachefs-tools (1:1.13.0-1~exp1) experimental; urgency=medium

  * QA Upload
  * New upstream release
    - Regenerate dependency patch
  * New build-dependency: librust-env-logger-dev
  * New build-dependency: librust-owo-colors-dev
  * Add missing character in previous changelog entry
    (s/tom/toml)

 -- Jonathan Carter <jcc@debian.org>  Mon, 06 Jan 2025 12:37:38 +0200

bcachefs-tools (1:1.9.4-1~exp1) experimental; urgency=medium

  * New upstream release
  * Remove build-dependency on librust-colored-2-dev (no longer needed)
  * New build-dependencies: librust-rustix-dev, rustfmt,
                            librust-memoffset-06-dev -> librust-memoffset-dev
  * Refresh build-deps patch
  * Add upstream metadata
  * Remove self from maintaners (orphaning package)

 -- Jonathan Carter <jcc@debian.org>  Sat, 20 Jul 2024 04:19:03 +0200

bcachefs-tools (1:1.9.2-1) experimental; urgency=medium

  * New upstream release
  * Fix Vcs fields in debian/control

 -- Jonathan Carter <jcc@debian.org>  Thu, 11 Jul 2024 15:01:59 +0200

bcachefs-tools (1:1.9.1-1) unstable; urgency=medium

  * New upstream release
  * New build-depency: librust-strum-dev
  * Update copyright file

 -- Jonathan Carter <jcc@debian.org>  Thu, 20 Jun 2024 17:28:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: bcachefs-tools
-Maintainer: Jonathan Carter <jcc@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: utils
 Priority: optional
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                cargo,
+               rustfmt,
                python3:native,
                pkgconf,
                python3-docutils,
@@ -27,7 +28,6 @@
                librust-atty-0.2-dev (>= 0.2.14-~~),
                librust-log-0.4-dev,
                librust-log-0+std-dev,
-               librust-colored-2-dev,
                librust-clap-4-dev (>= 4.0.32-~~),
                librust-clap-4+derive-dev,
                librust-clap-4+wrap-help-dev,
@@ -43,18 +43,20 @@
                librust-either-1-dev (>= 1.5),
                librust-rpassword-7-dev,
                librust-byteorder-1-dev (>= 1.3),
+	       librust-owo-colors-dev,
 	       librust-strum-dev (>= 0.26),
+	       librust-env-logger-dev,
 #              -- bch_bindgen/Cargo.toml
 #              anyhow, uuid, byteorder are covered above
                librust-bitfield-0-dev (>= 0.14.0-~~),
-               librust-memoffset-0.6-dev,
+               librust-memoffset-dev,
                librust-bitflags-1-dev (>= 1.3.2-~~),
                librust-paste-1.0-dev,
                librust-pkg-config-0.3-dev,
-               librust-bindgen-0.66-dev
+               librust-bindgen-0.70-dev
 Homepage: https://bcachefs.org/
-Vcs-Git: https://salsa.debian.org/jcc/bcachefs-tools.git
-Vcs-Browser: https://salsa.debian.org/jcc/bcachefs-tools
+Vcs-Git: https://salsa.debian.org/debian/bcachefs-tools.git
+Vcs-Browser: https://salsa.debian.org/debian/bcachefs-tools
 
 Package: bcachefs-tools
 Architecture: linux-any
